<?php
	
	
/*
	University of Illinois/NCSA Open Source License for readopatt.php.

Copyright (c) 2008 Jim Champ/Surrey County Council 
All rights reserved.
Developed by: 		Jim Champ
                    www.devboats.co.uk/idmphp/
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimers. 

Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimers
in the documentation and/or other materials provided with the
distribution. 

Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
or promote products derived from this Software without specific prior
written permission. 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE. 
 
dsulist.php is intended to produce a text presentation of the principal attributes
 of the users in an LDAP directory. It keeps a rolling log of the directory contents
over last seven times the application is run, plus a once monthly file. Its readily
extensible for more or less attributes...  

 */

// Enter user id that will be used by ldap,
// password, the ldap server and the ldap root. 
// ldap root is the point at which the search will start
$ldap_pw = "";
$ldap_server = "";
$ldap_root = "o=organisation";
// LDAP Id in ldap cn=format of course
$ldap_id = "cn=uid,o=organisation" ;
// Use surname as the search key...
// retsrict replies to surnames starting with smi - we only need a
// few responses on screen to demonstrate what's going on 
$ldap_sr = "Smi*" ;
$ldap_sr = "SN=" . $ldap_sr;


// basic sequence with LDAP is connect, bind, search, interpret search
// result, close connection

// So we start by connecting to LDAP after pushing a status message up

echo "\n";
echo "Running test PHP Script : ";
$today = getdate();
echo $today['hours'] . ":" . str_pad($today['minutes'], 2, "0", STR_PAD_LEFT) . ", " . $today['mday'] . "/" . $today['mon'] . "/" . $today['year'];
echo "\n";

echo "Connecting to LDAP server...\n";

$ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!

if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	echo "Connection succeeded.\n";
	// we have now made an LDAP connection
} else { 
	echo " LDAP Authentication Failed\n";
	echo "User id and/or Password credentials were incorrect.\n";
	exit;
}

echo "Running the LDAP Search...\n";
// do the search
// this is the crucial bit - the 3rd param on LDAP search must include all attributes you need to return, 
// and specifically the operational attribute...
// when reading LDAP attributes its common (but not good) practice to leave the attrbute array blank, in which
// case PHP will return all normal attributes but no operational ones.
// see http://wwwphp.net/manual/en/function.ldap-search.php for full documentation on ldap_search
// you can experiment with this by commenting out the different calls below. 
// if you leave the array out only the non-operational attrs will be returned. If you specify
// just createTimeStamp then given name and sn won't return and so on...

$sr=@ldap_search($ds, $ldap_root, $ldap_sr, array("givenName", "sn", "createTimestamp") );  
//$sr=@ldap_search($ds, $ldap_root, $ldap_sr, array("sn", "createTimestamp") );  
// $sr=@ldap_search($ds, $ldap_root, $ldap_sr, array("createTimestamp") );  
// $sr=@ldap_search($ds, $ldap_root, $ldap_sr, array("givenName", "sn") );  

$entry = @ldap_first_entry($ds, $sr);
echo  @ldap_count_entries($ds, $sr) . " directory entries returned.\n";

while ($entry) {

	$attrs = @ldap_get_attributes($ds,$entry);

	$udn = @ldap_get_dn($ds,$entry);
	$udn =  str_ireplace("cn=",".",$udn) ;
	$udn =  str_ireplace(",ou=",".",$udn) ;
	$udn =  str_ireplace(",o=",".",$udn) ;
	echo "dn: " .$udn . "\t";
	echo "givenName: " . @$attrs["givenName"][0] ."\t";
	echo  "sn: " . @$attrs["sn"][0] . "\t";
	echo "createTimestamp" . @$attrs["createTimestamp"][0] . "\n";

	$entry = @ldap_next_entry($ds, $entry);
}


ldap_close($ds);

echo "test/demo PHP Script completed.\n\n";

exit();
?>
